"use strict";
/********************************************************************************
 * Copyright (C) 2018 TypeFox and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var git_env_provider_1 = require("../../node/env/git-env-provider");
var askpass_1 = require("../askpass/askpass");
var electron_git_env_provider_1 = require("./electron-git-env-provider");
exports.default = new inversify_1.ContainerModule(function (bind) {
    bind(electron_git_env_provider_1.ElectronGitEnvProvider).toSelf().inSingletonScope();
    bind(askpass_1.Askpass).toSelf();
    bind(git_env_provider_1.GitEnvProvider).toService(electron_git_env_provider_1.ElectronGitEnvProvider);
});
//# sourceMappingURL=electron-git-env-module.js.map