"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var upath_1 = require("upath");
var uri_1 = require("@theia/core/lib/common/uri");
var os_1 = require("@theia/core/lib/common/os");
var browser_1 = require("@theia/core/lib/browser");
var workspace_service_1 = require("@theia/workspace/lib/browser/workspace-service");
var config_service_1 = require("../common/protocol/config-service");
var sketches_service_1 = require("../common/protocol/sketches-service");
var arduino_frontend_contribution_1 = require("./arduino-frontend-contribution");
/**
 * This is workaround to have custom frontend binding for the default workspace, although we
 * already have a custom binding for the backend.
 */
var ArduinoWorkspaceService = /** @class */ (function (_super) {
    __extends(ArduinoWorkspaceService, _super);
    function ArduinoWorkspaceService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ArduinoWorkspaceService.prototype.getDefaultWorkspacePath = function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_1, _a, url, sketch, sketchDirUri_1, hash, uri_2, _b, candidateUris, candidateUris_1, candidateUris_1_1, uri_3, e_1_1, config, sketchDirUri, stat, sketches, sketch_1, uri, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        url = new URL(window.location.href);
                        sketch = url.searchParams.get('sketch');
                        if (!sketch) return [3 /*break*/, 7];
                        sketchDirUri_1 = new uri_1.default(sketch).toString();
                        return [4 /*yield*/, this.sketchService.isSketchFolder(sketchDirUri_1)];
                    case 1:
                        if (!_d.sent()) return [3 /*break*/, 7];
                        return [4 /*yield*/, this.configService.isInSketchDir(sketchDirUri_1)];
                    case 2:
                        if (!_d.sent()) return [3 /*break*/, 5];
                        if (!arduino_frontend_contribution_1.ArduinoAdvancedMode.TOGGLED) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.configService.getConfiguration()];
                    case 3: return [2 /*return*/, (_d.sent()).sketchDirUri];
                    case 4: return [2 /*return*/, sketchDirUri_1];
                    case 5: return [4 /*yield*/, this.configService.getConfiguration()];
                    case 6: return [2 /*return*/, (_d.sent()).sketchDirUri];
                    case 7:
                        hash = window.location.hash;
                        if (!(hash.length > 1 && hash.startsWith('#'))) return [3 /*break*/, 10];
                        uri_2 = this.toUri(hash.slice(1));
                        _b = uri_2;
                        if (!_b) return [3 /*break*/, 9];
                        return [4 /*yield*/, this.sketchService.isSketchFolder(uri_2)];
                    case 8:
                        _b = (_d.sent());
                        _d.label = 9;
                    case 9:
                        if (_b) {
                            return [2 /*return*/, this.openSketchFilesInNewWindow(uri_2)];
                        }
                        _d.label = 10;
                    case 10: return [4 /*yield*/, this.server.getRecentWorkspaces()];
                    case 11:
                        candidateUris = _d.sent();
                        _d.label = 12;
                    case 12:
                        _d.trys.push([12, 17, 18, 19]);
                        candidateUris_1 = __values(candidateUris), candidateUris_1_1 = candidateUris_1.next();
                        _d.label = 13;
                    case 13:
                        if (!!candidateUris_1_1.done) return [3 /*break*/, 16];
                        uri_3 = candidateUris_1_1.value;
                        return [4 /*yield*/, this.sketchService.isSketchFolder(uri_3)];
                    case 14:
                        if (_d.sent()) {
                            return [2 /*return*/, this.openSketchFilesInNewWindow(uri_3)];
                        }
                        _d.label = 15;
                    case 15:
                        candidateUris_1_1 = candidateUris_1.next();
                        return [3 /*break*/, 13];
                    case 16: return [3 /*break*/, 19];
                    case 17:
                        e_1_1 = _d.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 19];
                    case 18:
                        try {
                            if (candidateUris_1_1 && !candidateUris_1_1.done && (_a = candidateUris_1.return)) _a.call(candidateUris_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 19: return [4 /*yield*/, this.configService.getConfiguration()];
                    case 20:
                        config = _d.sent();
                        sketchDirUri = config.sketchDirUri;
                        return [4 /*yield*/, this.fileSystem.getFileStat(sketchDirUri)];
                    case 21:
                        stat = _d.sent();
                        if (!!stat) return [3 /*break*/, 24];
                        // The folder for the workspace root does not exist yet, create it.
                        return [4 /*yield*/, this.fileSystem.createFolder(sketchDirUri)];
                    case 22:
                        // The folder for the workspace root does not exist yet, create it.
                        _d.sent();
                        return [4 /*yield*/, this.sketchService.createNewSketch(sketchDirUri)];
                    case 23:
                        _d.sent();
                        _d.label = 24;
                    case 24: return [4 /*yield*/, this.sketchService.getSketches(sketchDirUri)];
                    case 25:
                        sketches = _d.sent();
                        if (!!sketches.length) return [3 /*break*/, 27];
                        return [4 /*yield*/, this.sketchService.createNewSketch(sketchDirUri)];
                    case 26:
                        sketch_1 = _d.sent();
                        sketches.unshift(sketch_1);
                        _d.label = 27;
                    case 27:
                        uri = sketches[0].uri;
                        this.server.setMostRecentlyUsedWorkspace(uri);
                        this.openSketchFilesInNewWindow(uri);
                        _c = arduino_frontend_contribution_1.ArduinoAdvancedMode.TOGGLED;
                        if (!_c) return [3 /*break*/, 29];
                        return [4 /*yield*/, this.configService.isInSketchDir(uri)];
                    case 28:
                        _c = (_d.sent());
                        _d.label = 29;
                    case 29:
                        if (!_c) return [3 /*break*/, 31];
                        return [4 /*yield*/, this.configService.getConfiguration()];
                    case 30: return [2 /*return*/, (_d.sent()).sketchDirUri];
                    case 31: return [2 /*return*/, uri];
                }
            });
        });
    };
    ArduinoWorkspaceService.prototype.toUri = function (uriPath) {
        if (uriPath) {
            return new uri_1.default(upath_1.toUnix(uriPath.slice(os_1.isWindows && uriPath.startsWith('/') ? 1 : 0))).withScheme('file').toString();
        }
        return undefined;
    };
    ArduinoWorkspaceService.prototype.openSketchFilesInNewWindow = function (uri) {
        return __awaiter(this, void 0, void 0, function () {
            var url, currentSketch, sketchUri, _a, _b, _c, hash;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        url = new URL(window.location.href);
                        currentSketch = url.searchParams.get('sketch');
                        sketchUri = new uri_1.default(uri);
                        if (!!currentSketch && new uri_1.default(currentSketch).toString() === sketchUri.toString()) {
                            return [2 /*return*/, uri];
                        }
                        url.searchParams.set('sketch', uri);
                        _a = arduino_frontend_contribution_1.ArduinoAdvancedMode.TOGGLED;
                        if (!_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.configService.isInSketchDir(uri)];
                    case 1:
                        _a = (_d.sent());
                        _d.label = 2;
                    case 2:
                        if (!_a) return [3 /*break*/, 4];
                        _b = url;
                        _c = uri_1.default.bind;
                        return [4 /*yield*/, this.configService.getConfiguration()];
                    case 3:
                        _b.hash = new (_c.apply(uri_1.default, [void 0, (_d.sent()).sketchDirUri]))().path.toString();
                        return [3 /*break*/, 6];
                    case 4: return [4 /*yield*/, this.fileSystem.getFsPath(sketchUri.toString())];
                    case 5:
                        hash = _d.sent();
                        if (hash) {
                            url.hash = sketchUri.path.toString();
                        }
                        _d.label = 6;
                    case 6:
                        // Preserve the current window if the `sketch` is not in the `searchParams`.
                        if (!currentSketch) {
                            setTimeout(function () { return window.location.href = url.toString(); }, 100);
                            return [2 /*return*/, uri];
                        }
                        this.windowService.openNewWindow(url.toString());
                        return [2 /*return*/, uri];
                }
            });
        });
    };
    __decorate([
        inversify_1.inject(sketches_service_1.SketchesService),
        __metadata("design:type", Object)
    ], ArduinoWorkspaceService.prototype, "sketchService", void 0);
    __decorate([
        inversify_1.inject(config_service_1.ConfigService),
        __metadata("design:type", Object)
    ], ArduinoWorkspaceService.prototype, "configService", void 0);
    __decorate([
        inversify_1.inject(browser_1.LabelProvider),
        __metadata("design:type", browser_1.LabelProvider)
    ], ArduinoWorkspaceService.prototype, "labelProvider", void 0);
    ArduinoWorkspaceService = __decorate([
        inversify_1.injectable()
    ], ArduinoWorkspaceService);
    return ArduinoWorkspaceService;
}(workspace_service_1.WorkspaceService));
exports.ArduinoWorkspaceService = ArduinoWorkspaceService;
//# sourceMappingURL=arduino-workspace-service.js.map