"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var inversify_1 = require("inversify");
var list_item_renderer_1 = require("../components/component-list/list-item-renderer");
var BoardItemRenderer = /** @class */ (function (_super) {
    __extends(BoardItemRenderer, _super);
    function BoardItemRenderer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BoardItemRenderer.prototype.renderItem = function (item, install) {
        var name = React.createElement("span", { className: 'name' }, item.name);
        var author = React.createElement("span", { className: 'author' }, item.author);
        var installedVersion = !!item.installedVersion && React.createElement("div", { className: 'version-info' },
            React.createElement("span", { className: 'version' },
                "Version ",
                item.installedVersion),
            React.createElement("span", { className: 'installed' }, "INSTALLED"));
        var summary = React.createElement("div", { className: 'summary' }, item.summary);
        var description = React.createElement("div", { className: 'summary' }, item.description);
        var moreInfo = !!item.moreInfoLink && React.createElement("a", { href: item.moreInfoLink, onClick: this.onClick }, "More info");
        var installButton = item.installable && !item.installedVersion &&
            React.createElement("button", { className: 'install', onClick: install.bind(this, item) }, "INSTALL");
        var versions = (function () {
            var availableVersions = item.availableVersions;
            if (!!item.installedVersion || availableVersions.length === 0) {
                return undefined;
            }
            else if (availableVersions.length === 1) {
                return React.createElement("label", null, availableVersions[0]);
            }
            else {
                return React.createElement("select", null, item.availableVersions.map(function (version) { return React.createElement("option", { value: version, key: version }, version); }));
            }
        })();
        return React.createElement("div", { className: 'component-list-item noselect' },
            React.createElement("div", { className: 'header' },
                React.createElement("span", null,
                    name,
                    " by ",
                    author),
                installedVersion),
            React.createElement("div", { className: 'content' },
                summary,
                description),
            React.createElement("div", { className: 'info' }, moreInfo),
            React.createElement("div", { className: 'footer' },
                installButton,
                versions));
    };
    BoardItemRenderer = __decorate([
        inversify_1.injectable()
    ], BoardItemRenderer);
    return BoardItemRenderer;
}(list_item_renderer_1.ListItemRenderer));
exports.BoardItemRenderer = BoardItemRenderer;
//# sourceMappingURL=boards-item-renderer.js.map