"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var core_1 = require("@theia/core");
var boards_service_1 = require("../../common/protocol/boards-service");
var browser_1 = require("@theia/core/lib/browser");
var BoardsServiceClientImpl = /** @class */ (function () {
    function BoardsServiceClientImpl() {
        this.onAttachedBoardsChangedEmitter = new core_1.Emitter();
        this.onBoardInstalledEmitter = new core_1.Emitter();
        this.onSelectedBoardsConfigChangedEmitter = new core_1.Emitter();
        this._boardsConfig = {};
        this.onBoardsChanged = this.onAttachedBoardsChangedEmitter.event;
        this.onBoardInstalled = this.onBoardInstalledEmitter.event;
        this.onBoardsConfigChanged = this.onSelectedBoardsConfigChangedEmitter.event;
    }
    BoardsServiceClientImpl.prototype.init = function () {
        this.loadState();
    };
    BoardsServiceClientImpl.prototype.notifyAttachedBoardsChanged = function (event) {
        this.logger.info('Attached boards changed: ', JSON.stringify(event));
        var detachedBoards = boards_service_1.AttachedBoardsChangeEvent.diff(event).detached.filter(boards_service_1.AttachedSerialBoard.is).map(function (_a) {
            var port = _a.port;
            return port;
        });
        var _a = this.boardsConfig, selectedPort = _a.selectedPort, selectedBoard = _a.selectedBoard;
        this.onAttachedBoardsChangedEmitter.fire(event);
        // Dynamically unset the port if the selected board was an attached one and we detached it.
        if (!!selectedPort && detachedBoards.indexOf(selectedPort) !== -1) {
            this.boardsConfig = {
                selectedBoard: selectedBoard,
                selectedPort: undefined
            };
        }
    };
    BoardsServiceClientImpl.prototype.notifyBoardInstalled = function (event) {
        this.logger.info('Board installed: ', JSON.stringify(event));
        this.onBoardInstalledEmitter.fire(event);
    };
    Object.defineProperty(BoardsServiceClientImpl.prototype, "boardsConfig", {
        get: function () {
            return this._boardsConfig;
        },
        set: function (config) {
            var _this = this;
            this.logger.info('Board config changed: ', JSON.stringify(config));
            this._boardsConfig = config;
            this.saveState().then(function () { return _this.onSelectedBoardsConfigChangedEmitter.fire(_this._boardsConfig); });
        },
        enumerable: true,
        configurable: true
    });
    BoardsServiceClientImpl.prototype.saveState = function () {
        return this.storageService.setData('boards-config', this.boardsConfig);
    };
    BoardsServiceClientImpl.prototype.loadState = function () {
        return __awaiter(this, void 0, void 0, function () {
            var boardsConfig;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.storageService.getData('boards-config')];
                    case 1:
                        boardsConfig = _a.sent();
                        if (boardsConfig) {
                            this.boardsConfig = boardsConfig;
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    __decorate([
        inversify_1.inject(core_1.ILogger),
        __metadata("design:type", Object)
    ], BoardsServiceClientImpl.prototype, "logger", void 0);
    __decorate([
        inversify_1.inject(browser_1.LocalStorageService),
        __metadata("design:type", browser_1.LocalStorageService)
    ], BoardsServiceClientImpl.prototype, "storageService", void 0);
    __decorate([
        inversify_1.postConstruct(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], BoardsServiceClientImpl.prototype, "init", null);
    BoardsServiceClientImpl = __decorate([
        inversify_1.injectable()
    ], BoardsServiceClientImpl);
    return BoardsServiceClientImpl;
}());
exports.BoardsServiceClientImpl = BoardsServiceClientImpl;
//# sourceMappingURL=boards-service-client-impl.js.map