"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var debounce = require("lodash.debounce");
var installation_progress_dialog_1 = require("../installation-progress-dialog");
var search_bar_1 = require("./search-bar");
var component_list_1 = require("./component-list");
var FilterableListContainer = /** @class */ (function (_super) {
    __extends(FilterableListContainer, _super);
    function FilterableListContainer(props) {
        var _this = _super.call(this, props) || this;
        _this.handleFilterTextChange = function (filterText) {
            _this.setState({ filterText: filterText });
            _this.search(filterText);
        };
        _this.state = {
            filterText: '',
            items: []
        };
        return _this;
    }
    FilterableListContainer.prototype.componentWillMount = function () {
        this.search = debounce(this.search, 500);
        this.handleFilterTextChange('');
    };
    FilterableListContainer.prototype.render = function () {
        return React.createElement("div", { className: 'filterable-list-container' },
            this.renderSearchFilter(),
            this.renderSearchBar(),
            this.renderComponentList());
    };
    FilterableListContainer.prototype.renderSearchFilter = function () {
        return undefined;
    };
    FilterableListContainer.prototype.renderSearchBar = function () {
        return React.createElement(search_bar_1.SearchBar, { resolveFocus: this.props.resolveFocus, filterText: this.state.filterText, onFilterTextChanged: this.handleFilterTextChange });
    };
    FilterableListContainer.prototype.renderComponentList = function () {
        var _a = this.props, itemLabel = _a.itemLabel, resolveContainer = _a.resolveContainer, itemRenderer = _a.itemRenderer;
        return React.createElement(component_list_1.ComponentList, { items: this.state.items, itemLabel: itemLabel, itemRenderer: itemRenderer, install: this.install.bind(this), resolveContainer: resolveContainer });
    };
    FilterableListContainer.prototype.search = function (query) {
        var _this = this;
        var searchable = this.props.searchable;
        searchable.search({ query: query.trim() }).then(function (result) {
            var items = result.items;
            _this.setState({
                items: _this.sort(items)
            });
        });
    };
    FilterableListContainer.prototype.sort = function (items) {
        var itemLabel = this.props.itemLabel;
        return items.sort(function (left, right) { return itemLabel(left).localeCompare(itemLabel(right)); });
    };
    FilterableListContainer.prototype.install = function (item) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, installable, searchable, itemLabel, dialog, items;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.props, installable = _a.installable, searchable = _a.searchable, itemLabel = _a.itemLabel;
                        dialog = new installation_progress_dialog_1.InstallationProgressDialog(itemLabel(item));
                        dialog.open();
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, , 4, 5]);
                        return [4 /*yield*/, installable.install(item)];
                    case 2:
                        _b.sent();
                        return [4 /*yield*/, searchable.search({ query: this.state.filterText })];
                    case 3:
                        items = (_b.sent()).items;
                        this.setState({ items: this.sort(items) });
                        return [3 /*break*/, 5];
                    case 4:
                        dialog.close();
                        return [7 /*endfinally*/];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    return FilterableListContainer;
}(React.Component));
exports.FilterableListContainer = FilterableListContainer;
//# sourceMappingURL=filterable-list-container.js.map