"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var core_1 = require("@theia/core");
var MonitorModel = /** @class */ (function () {
    function MonitorModel() {
        this.onChangeEmitter = new core_1.Emitter();
        this.onChange = this.onChangeEmitter.event;
        this._autoscroll = true;
        this._timestamp = false;
        this.lineEnding = '\n';
    }
    Object.defineProperty(MonitorModel.prototype, "autoscroll", {
        get: function () {
            return this._autoscroll;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MonitorModel.prototype, "timestamp", {
        get: function () {
            return this._timestamp;
        },
        enumerable: true,
        configurable: true
    });
    MonitorModel.prototype.toggleAutoscroll = function () {
        this._autoscroll = !this._autoscroll;
        this.onChangeEmitter.fire(undefined);
    };
    MonitorModel.prototype.toggleTimestamp = function () {
        this._timestamp = !this._timestamp;
        this.onChangeEmitter.fire(undefined);
    };
    MonitorModel.prototype.restore = function (model) {
        this._autoscroll = model.autoscroll;
        this._timestamp = model.timestamp;
        this.baudRate = model.baudRate;
        this.lineEnding = model.lineEnding;
    };
    MonitorModel.prototype.store = function () {
        return {
            autoscroll: this._autoscroll,
            timestamp: this._timestamp,
            baudRate: this.baudRate,
            lineEnding: this.lineEnding
        };
    };
    MonitorModel = __decorate([
        inversify_1.injectable()
    ], MonitorModel);
    return MonitorModel;
}());
exports.MonitorModel = MonitorModel;
//# sourceMappingURL=monitor-model.js.map