"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var AttachedBoardsChangeEvent;
(function (AttachedBoardsChangeEvent) {
    function diff(event) {
        var diff = function (left, right) {
            return left.filter(function (item) { return right.indexOf(item) === -1; });
        };
        var newBoards = event.newState.boards;
        var oldBoards = event.oldState.boards;
        return {
            detached: diff(oldBoards, newBoards),
            attached: diff(newBoards, oldBoards)
        };
    }
    AttachedBoardsChangeEvent.diff = diff;
})(AttachedBoardsChangeEvent = exports.AttachedBoardsChangeEvent || (exports.AttachedBoardsChangeEvent = {}));
exports.BoardsServiceClient = Symbol('BoardsServiceClient');
exports.BoardsServicePath = '/services/boards-service';
exports.BoardsService = Symbol('BoardsService');
var Board;
(function (Board) {
    function is(board) {
        return !!board && 'name' in board;
    }
    Board.is = is;
    function equals(left, right) {
        return left.name === right.name && left.fqbn === right.fqbn;
    }
    Board.equals = equals;
    function compare(left, right) {
        var result = left.name.localeCompare(right.name);
        if (result === 0) {
            result = (left.fqbn || '').localeCompare(right.fqbn || '');
        }
        return result;
    }
    Board.compare = compare;
    function installed(board) {
        return !!board.fqbn;
    }
    Board.installed = installed;
})(Board = exports.Board || (exports.Board = {}));
var AttachedSerialBoard;
(function (AttachedSerialBoard) {
    function is(b) {
        return !!b && 'port' in b;
    }
    AttachedSerialBoard.is = is;
})(AttachedSerialBoard = exports.AttachedSerialBoard || (exports.AttachedSerialBoard = {}));
var AttachedNetworkBoard;
(function (AttachedNetworkBoard) {
    function is(b) {
        return 'address' in b && 'port' in b;
    }
    AttachedNetworkBoard.is = is;
})(AttachedNetworkBoard = exports.AttachedNetworkBoard || (exports.AttachedNetworkBoard = {}));
//# sourceMappingURL=boards-service.js.map