"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var os = require("os");
var which = require("which");
var cp = require("child_process");
var path_1 = require("path");
var inversify_1 = require("inversify");
var core_1 = require("@theia/core");
var file_uri_1 = require("@theia/core/lib/node/file-uri");
var ArduinoCli = /** @class */ (function () {
    function ArduinoCli() {
    }
    ArduinoCli.prototype.getExecPath = function () {
        return __awaiter(this, void 0, void 0, function () {
            var build;
            return __generator(this, function (_a) {
                build = path_1.join(__dirname, '..', '..', 'build');
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        which("arduino-cli" + (os.platform() === 'win32' ? '.exe' : ''), { path: "" + process.env.PATH + path_1.delimiter + build }, function (err, path) {
                            if (err) {
                                reject(err);
                                return;
                            }
                            resolve(path);
                        });
                    })];
            });
        });
    };
    ArduinoCli.prototype.getDefaultConfig = function () {
        return __awaiter(this, void 0, void 0, function () {
            var command;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getExecPath()];
                    case 1:
                        command = _a.sent();
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                cp.execFile(command, ['config', 'dump', '--format', 'json'], { encoding: 'utf8' }, function (error, stdout, stderr) {
                                    if (error) {
                                        throw error;
                                    }
                                    if (stderr) {
                                        throw new Error(stderr);
                                    }
                                    var _a = JSON.parse(stdout.trim()), sketchbook_path = _a.sketchbook_path, arduino_data = _a.arduino_data;
                                    if (!sketchbook_path) {
                                        reject(new Error("Could not parse config. 'sketchbook_path' was missing from: " + stdout));
                                        return;
                                    }
                                    if (!arduino_data) {
                                        reject(new Error("Could not parse config. 'arduino_data' was missing from: " + stdout));
                                        return;
                                    }
                                    resolve({
                                        sketchDirUri: file_uri_1.FileUri.create(sketchbook_path).toString(),
                                        dataDirUri: file_uri_1.FileUri.create(arduino_data).toString()
                                    });
                                });
                            })];
                }
            });
        });
    };
    __decorate([
        inversify_1.inject(core_1.ILogger),
        __metadata("design:type", Object)
    ], ArduinoCli.prototype, "logger", void 0);
    ArduinoCli = __decorate([
        inversify_1.injectable()
    ], ArduinoCli);
    return ArduinoCli;
}());
exports.ArduinoCli = ArduinoCli;
//# sourceMappingURL=arduino-cli.js.map