"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var PQueue = require("p-queue");
var inversify_1 = require("inversify");
var logger_1 = require("@theia/core/lib/common/logger");
var boards_service_1 = require("../common/protocol/boards-service");
var core_pb_1 = require("./cli-protocol/commands/core_pb");
var core_client_provider_1 = require("./core-client-provider");
var board_pb_1 = require("./cli-protocol/commands/board_pb");
var tool_output_service_1 = require("../common/protocol/tool-output-service");
var BoardsServiceImpl = /** @class */ (function () {
    function BoardsServiceImpl() {
        this.discoveryInitialized = false;
        /**
         * Poor man's serial discovery:
         * Stores the state of the currently discovered, attached boards.
         * This state is updated via periodical polls.
         */
        this._attachedBoards = { boards: [] };
        this.queue = new PQueue({ autoStart: true, concurrency: 1 });
    }
    BoardsServiceImpl.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.discoveryTimer = setInterval(function () {
                    _this.discoveryLogger.trace('Discovering attached boards...');
                    _this.doGetAttachedBoards().then(function (_a) {
                        var boards = _a.boards;
                        var update = function (oldState, newState, message) {
                            _this._attachedBoards = { boards: newState };
                            _this.discoveryLogger.info(message + " - Discovered boards: " + JSON.stringify(newState));
                            if (_this.client) {
                                _this.client.notifyAttachedBoardsChanged({
                                    oldState: {
                                        boards: oldState
                                    },
                                    newState: {
                                        boards: newState
                                    }
                                });
                            }
                        };
                        var sortedBoards = boards.sort(boards_service_1.Board.compare);
                        _this.discoveryLogger.trace("Discovery done. " + JSON.stringify(sortedBoards));
                        if (!_this.discoveryInitialized) {
                            update([], sortedBoards, 'Initialized attached boards.');
                            _this.discoveryInitialized = true;
                        }
                        else {
                            _this.getAttachedBoards().then(function (_a) {
                                var currentBoards = _a.boards;
                                _this.discoveryLogger.trace("Updating discovered boards... " + JSON.stringify(currentBoards));
                                if (currentBoards.length !== sortedBoards.length) {
                                    update(currentBoards, sortedBoards, 'Updated discovered boards.');
                                    return;
                                }
                                // `currentBoards` is already sorted.
                                for (var i = 0; i < sortedBoards.length; i++) {
                                    if (boards_service_1.Board.compare(sortedBoards[i], currentBoards[i]) !== 0) {
                                        update(currentBoards, sortedBoards, 'Updated discovered boards.');
                                        return;
                                    }
                                }
                                _this.discoveryLogger.trace('No new boards were discovered.');
                            });
                        }
                    });
                }, 1000);
                return [2 /*return*/];
            });
        });
    };
    BoardsServiceImpl.prototype.setClient = function (client) {
        this.client = client;
    };
    BoardsServiceImpl.prototype.dispose = function () {
        if (this.discoveryTimer !== undefined) {
            clearInterval(this.discoveryTimer);
        }
    };
    BoardsServiceImpl.prototype.getAttachedBoards = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this._attachedBoards];
            });
        });
    };
    BoardsServiceImpl.prototype.doGetAttachedBoards = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, this.queue.add(function () {
                        return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
                            var e_1, _a, e_2, _b, coreClient, boards, client, instance, req, resp, _c, _d, portsList, protocol, address, _e, _f, board, name_1, fqbn, port;
                            return __generator(this, function (_g) {
                                switch (_g.label) {
                                    case 0: return [4 /*yield*/, this.coreClientProvider.getClient()];
                                    case 1:
                                        coreClient = _g.sent();
                                        boards = [];
                                        if (!coreClient) {
                                            resolve({ boards: boards });
                                            return [2 /*return*/];
                                        }
                                        client = coreClient.client, instance = coreClient.instance;
                                        req = new board_pb_1.BoardListReq();
                                        req.setInstance(instance);
                                        return [4 /*yield*/, new Promise(function (resolve, reject) { return client.boardList(req, function (err, resp) { return (!!err ? reject : resolve)(!!err ? err : resp); }); })];
                                    case 2:
                                        resp = _g.sent();
                                        try {
                                            for (_c = __values(resp.getPortsList()), _d = _c.next(); !_d.done; _d = _c.next()) {
                                                portsList = _d.value;
                                                protocol = portsList.getProtocol();
                                                address = portsList.getAddress();
                                                try {
                                                    for (_e = __values(portsList.getBoardsList()), _f = _e.next(); !_f.done; _f = _e.next()) {
                                                        board = _f.value;
                                                        name_1 = board.getName() || 'unknown';
                                                        fqbn = board.getFqbn();
                                                        port = address;
                                                        if (protocol === 'serial') {
                                                            boards.push({
                                                                name: name_1,
                                                                fqbn: fqbn,
                                                                port: port
                                                            });
                                                        }
                                                        else { // We assume, it is a `network` board.
                                                            boards.push({
                                                                name: name_1,
                                                                fqbn: fqbn,
                                                                address: address,
                                                                port: port
                                                            });
                                                        }
                                                    }
                                                }
                                                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                                                finally {
                                                    try {
                                                        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                                                    }
                                                    finally { if (e_2) throw e_2.error; }
                                                }
                                            }
                                        }
                                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                                        finally {
                                            try {
                                                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                                            }
                                            finally { if (e_1) throw e_1.error; }
                                        }
                                        // TODO: remove mock board!
                                        // boards.push(...[
                                        //     <AttachedSerialBoard>{ name: 'Arduino/Genuino Uno', fqbn: 'arduino:avr:uno', port: '/dev/cu.usbmodem14201' },
                                        //     <AttachedSerialBoard>{ name: 'Arduino/Genuino Uno', fqbn: 'arduino:avr:uno', port: '/dev/cu.usbmodem142xx' },
                                        // ]);
                                        resolve({ boards: boards });
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                    })];
            });
        });
    };
    BoardsServiceImpl.prototype.search = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var coreClient, client, instance, installedPlatformsReq, installedPlatformsResp, installedPlatforms, req, resp, items;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.coreClientProvider.getClient()];
                    case 1:
                        coreClient = _a.sent();
                        if (!coreClient) {
                            return [2 /*return*/, { items: [] }];
                        }
                        client = coreClient.client, instance = coreClient.instance;
                        installedPlatformsReq = new core_pb_1.PlatformListReq();
                        installedPlatformsReq.setInstance(instance);
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                return client.platformList(installedPlatformsReq, function (err, resp) { return (!!err ? reject : resolve)(!!err ? err : resp); });
                            })];
                    case 2:
                        installedPlatformsResp = _a.sent();
                        installedPlatforms = installedPlatformsResp.getInstalledPlatformList();
                        req = new core_pb_1.PlatformSearchReq();
                        req.setSearchArgs(options.query || "");
                        req.setInstance(instance);
                        return [4 /*yield*/, new Promise(function (resolve, reject) { return client.platformSearch(req, function (err, resp) { return (!!err ? reject : resolve)(!!err ? err : resp); }); })];
                    case 3:
                        resp = _a.sent();
                        items = resp.getSearchOutputList().map(function (item) {
                            var installedVersion;
                            var matchingPlatform = installedPlatforms.find(function (ip) { return ip.getId() === item.getId(); });
                            if (!!matchingPlatform) {
                                installedVersion = matchingPlatform.getInstalled();
                            }
                            var result = {
                                id: item.getId(),
                                name: item.getName(),
                                author: item.getMaintainer(),
                                availableVersions: [item.getLatest()],
                                description: item.getBoardsList().map(function (b) { return b.getName(); }).join(", "),
                                installable: true,
                                summary: "Boards included in this package:",
                                installedVersion: installedVersion,
                                boards: item.getBoardsList().map(function (b) { return ({ name: b.getName(), fqbn: b.getFqbn() }); }),
                                moreInfoLink: item.getWebsite()
                            };
                            return result;
                        });
                        return [2 /*return*/, { items: items }];
                }
            });
        });
    };
    BoardsServiceImpl.prototype.install = function (pkg) {
        return __awaiter(this, void 0, void 0, function () {
            var coreClient, client, instance, _a, platform, boardName, req, resp;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.coreClientProvider.getClient()];
                    case 1:
                        coreClient = _b.sent();
                        if (!coreClient) {
                            return [2 /*return*/];
                        }
                        client = coreClient.client, instance = coreClient.instance;
                        _a = __read(pkg.id.split(":"), 2), platform = _a[0], boardName = _a[1];
                        req = new core_pb_1.PlatformInstallReq();
                        req.setInstance(instance);
                        req.setArchitecture(boardName);
                        req.setPlatformPackage(platform);
                        req.setVersion(pkg.availableVersions[0]);
                        console.info("Starting board installation", pkg);
                        resp = client.platformInstall(req);
                        resp.on('data', function (r) {
                            var prog = r.getProgress();
                            if (prog && prog.getFile()) {
                                _this.toolOutputService.publishNewOutput("board download", "downloading " + prog.getFile() + "\n");
                            }
                        });
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                resp.on('end', resolve);
                                resp.on('error', reject);
                            })];
                    case 2:
                        _b.sent();
                        if (this.client) {
                            this.client.notifyBoardInstalled({ pkg: pkg });
                        }
                        console.info("Board installation done", pkg);
                        return [2 /*return*/];
                }
            });
        });
    };
    __decorate([
        inversify_1.inject(logger_1.ILogger),
        inversify_1.named('discovery'),
        __metadata("design:type", Object)
    ], BoardsServiceImpl.prototype, "discoveryLogger", void 0);
    __decorate([
        inversify_1.inject(core_client_provider_1.CoreClientProvider),
        __metadata("design:type", Object)
    ], BoardsServiceImpl.prototype, "coreClientProvider", void 0);
    __decorate([
        inversify_1.inject(tool_output_service_1.ToolOutputServiceServer),
        __metadata("design:type", Object)
    ], BoardsServiceImpl.prototype, "toolOutputService", void 0);
    __decorate([
        inversify_1.postConstruct(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Promise)
    ], BoardsServiceImpl.prototype, "init", null);
    BoardsServiceImpl = __decorate([
        inversify_1.injectable()
    ], BoardsServiceImpl);
    return BoardsServiceImpl;
}());
exports.BoardsServiceImpl = BoardsServiceImpl;
//# sourceMappingURL=boards-service-impl.js.map