"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var which = require("which");
var os = require("os");
var path_1 = require("path");
var inversify_1 = require("inversify");
var node_1 = require("@theia/languages/lib/node");
var ArduinoLanguageServerContribution = /** @class */ (function (_super) {
    __extends(ArduinoLanguageServerContribution, _super);
    function ArduinoLanguageServerContribution() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.description = {
            id: 'ino',
            name: 'Arduino',
            documentSelector: ['ino'],
            fileEvents: ['**/*.ino']
        };
        return _this;
    }
    Object.defineProperty(ArduinoLanguageServerContribution.prototype, "id", {
        get: function () {
            return this.description.id;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ArduinoLanguageServerContribution.prototype, "name", {
        get: function () {
            return this.description.name;
        },
        enumerable: true,
        configurable: true
    });
    ArduinoLanguageServerContribution.prototype.start = function (clientConnection, options) {
        return __awaiter(this, void 0, void 0, function () {
            var clangd, languageServer, cli, args, board, serverConnection;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.resolveExecutable('clangd')];
                    case 1:
                        clangd = _a.sent();
                        return [4 /*yield*/, this.resolveExecutable('arduino-language-server')];
                    case 2:
                        languageServer = _a.sent();
                        return [4 /*yield*/, this.resolveExecutable('arduino-cli')];
                    case 3:
                        cli = _a.sent();
                        args = ['-clangd', clangd, '-cli', cli];
                        if (options.parameters && options.parameters.selectedBoard) {
                            board = options.parameters.selectedBoard;
                            if (board.fqbn) {
                                args.push('-fqbn', board.fqbn);
                            }
                            if (board.name) {
                                args.push('-board-name', "\"" + board.name + "\"");
                            }
                        }
                        console.log("Starting language server " + languageServer + " " + args.join(' '));
                        return [4 /*yield*/, this.createProcessStreamConnectionAsync(languageServer, args)];
                    case 4:
                        serverConnection = _a.sent();
                        this.forward(clientConnection, serverConnection);
                        return [2 /*return*/];
                }
            });
        });
    };
    ArduinoLanguageServerContribution.prototype.resolveExecutable = function (name) {
        return new Promise(function (resolve, reject) {
            var path = "" + process.env.PATH + path_1.delimiter + path_1.join(__dirname, '..', '..', '..', 'build');
            var suffix = os.platform() === 'win32' ? '.exe' : '';
            which(name + suffix, { path: path }, function (err, execPath) {
                if (err) {
                    reject(err);
                }
                else {
                    resolve(execPath);
                }
            });
        });
    };
    ArduinoLanguageServerContribution = __decorate([
        inversify_1.injectable()
    ], ArduinoLanguageServerContribution);
    return ArduinoLanguageServerContribution;
}(node_1.BaseLanguageServerContribution));
exports.ArduinoLanguageServerContribution = ArduinoLanguageServerContribution;
//# sourceMappingURL=arduino-language-server-contribution.js.map