"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var uuid_1 = require("uuid");
var util_1 = require("util");
var inversify_1 = require("inversify");
var core_1 = require("@theia/core");
var monitor_service_1 = require("../../common/protocol/monitor-service");
var monitor_pb_1 = require("../cli-protocol/monitor/monitor_pb");
var monitor_client_provider_1 = require("./monitor-client-provider");
var google_protobuf_struct_pb = require("google-protobuf/google/protobuf/struct_pb");
var MonitorError;
(function (MonitorError) {
    function is(error) {
        return typeof error.code === 'number';
    }
    MonitorError.is = is;
    /**
     * The frontend has refreshed the browser, for instance.
     */
    function isClientCancelledError(error) {
        return error.code === 1 && error.message === 'Cancelled on client';
    }
    MonitorError.isClientCancelledError = isClientCancelledError;
    /**
     * When detaching a physical device when the duplex channel is still opened.
     */
    function isDeviceNotConfiguredError(error) {
        return error.code === 2 && error.message === 'device not configured';
    }
    MonitorError.isDeviceNotConfiguredError = isDeviceNotConfiguredError;
})(MonitorError || (MonitorError = {}));
var MonitorServiceImpl = /** @class */ (function () {
    function MonitorServiceImpl() {
        this.connections = new Map();
    }
    MonitorServiceImpl.prototype.setClient = function (client) {
        this.client = client;
    };
    MonitorServiceImpl.prototype.dispose = function () {
        var e_1, _a;
        try {
            for (var _b = __values(this.connections.entries()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), connectionId = _d[0], duplex = _d[1];
                this.doDisconnect(connectionId, duplex);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    MonitorServiceImpl.prototype.getConnectionIds = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, Array.from(this.connections.keys())];
            });
        });
    };
    MonitorServiceImpl.prototype.connect = function (config) {
        return __awaiter(this, void 0, void 0, function () {
            var client, duplex, connectionId, toDispose, type, port, req, monitorConfig, obj;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.monitorClientProvider.client];
                    case 1:
                        client = _a.sent();
                        duplex = client.streamingOpen();
                        connectionId = uuid_1.v4();
                        toDispose = new core_1.DisposableCollection(core_1.Disposable.create(function () { return _this.disconnect(connectionId); }));
                        duplex.on('error', (function (error) {
                            if (MonitorError.is(error) && (MonitorError.isClientCancelledError(error)
                                || MonitorError.isDeviceNotConfiguredError(error))) {
                                if (_this.client) {
                                    _this.client.notifyError(error);
                                }
                            }
                            _this.logger.error("Error occurred for connection " + connectionId + ".", error);
                            toDispose.dispose();
                        }).bind(this));
                        duplex.on('data', (function (resp) {
                            if (_this.client) {
                                var raw = resp.getData();
                                var data = typeof raw === 'string' ? raw : new util_1.TextDecoder('utf8').decode(raw);
                                _this.client.notifyRead({ connectionId: connectionId, data: data });
                            }
                        }).bind(this));
                        type = config.type, port = config.port;
                        req = new monitor_pb_1.StreamingOpenReq();
                        monitorConfig = new monitor_pb_1.MonitorConfig();
                        monitorConfig.setType(this.mapType(type));
                        monitorConfig.setTarget(port);
                        if (config.baudRate !== undefined) {
                            obj = google_protobuf_struct_pb.Struct.fromJavaScript({ 'BaudRate': config.baudRate });
                            monitorConfig.setAdditionalconfig(obj);
                        }
                        req.setMonitorconfig(monitorConfig);
                        return [2 /*return*/, new Promise(function (resolve) {
                                duplex.write(req, function () {
                                    _this.connections.set(connectionId, { toDispose: toDispose, duplex: duplex });
                                    resolve({ connectionId: connectionId });
                                });
                            })];
                }
            });
        });
    };
    MonitorServiceImpl.prototype.disconnect = function (connectionId) {
        return __awaiter(this, void 0, void 0, function () {
            var disposable, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.logger.info(">>> Received disconnect request for connection: " + connectionId);
                        disposable = this.connections.get(connectionId);
                        if (!disposable) {
                            this.logger.warn("<<< No connection was found for ID: " + connectionId);
                            return [2 /*return*/, false];
                        }
                        return [4 /*yield*/, this.doDisconnect(connectionId, disposable)];
                    case 1:
                        result = _a.sent();
                        if (result) {
                            this.logger.info("<<< Successfully disconnected from " + connectionId + ".");
                        }
                        else {
                            this.logger.info("<<< Could not disconnected from " + connectionId + ".");
                        }
                        return [2 /*return*/, result];
                }
            });
        });
    };
    MonitorServiceImpl.prototype.doDisconnect = function (connectionId, monitorDuplex) {
        return __awaiter(this, void 0, void 0, function () {
            var duplex;
            return __generator(this, function (_a) {
                duplex = monitorDuplex.duplex;
                this.logger.info(">>> Disposing monitor connection: " + connectionId + "...");
                try {
                    duplex.cancel();
                    this.connections.delete(connectionId);
                    this.logger.info("<<< Connection disposed: " + connectionId + ".");
                    return [2 /*return*/, true];
                }
                catch (e) {
                    this.logger.error("<<< Error occurred when disposing monitor connection: " + connectionId + ". " + e);
                    return [2 /*return*/, false];
                }
                return [2 /*return*/];
            });
        });
    };
    MonitorServiceImpl.prototype.send = function (connectionId, data) {
        return __awaiter(this, void 0, void 0, function () {
            var duplex, req_1;
            return __generator(this, function (_a) {
                duplex = this.duplex(connectionId);
                if (duplex) {
                    req_1 = new monitor_pb_1.StreamingOpenReq();
                    req_1.setData(new util_1.TextEncoder().encode(data));
                    return [2 /*return*/, new Promise(function (resolve) { return duplex.duplex.write(req_1, resolve); })];
                }
                else {
                    throw new Error("No connection with ID: " + connectionId + ".");
                }
                return [2 /*return*/];
            });
        });
    };
    MonitorServiceImpl.prototype.mapType = function (type) {
        switch (type) {
            case monitor_service_1.ConnectionType.SERIAL: return monitor_pb_1.MonitorConfig.TargetType.SERIAL;
            default: return monitor_pb_1.MonitorConfig.TargetType.SERIAL;
        }
    };
    MonitorServiceImpl.prototype.duplex = function (connectionId) {
        var monitorClient = this.connections.get(connectionId);
        if (!monitorClient) {
            this.logger.warn("Could not find monitor client for connection ID: " + connectionId);
        }
        return monitorClient;
    };
    __decorate([
        inversify_1.inject(core_1.ILogger),
        inversify_1.named('monitor-service'),
        __metadata("design:type", Object)
    ], MonitorServiceImpl.prototype, "logger", void 0);
    __decorate([
        inversify_1.inject(monitor_client_provider_1.MonitorClientProvider),
        __metadata("design:type", monitor_client_provider_1.MonitorClientProvider)
    ], MonitorServiceImpl.prototype, "monitorClientProvider", void 0);
    MonitorServiceImpl = __decorate([
        inversify_1.injectable()
    ], MonitorServiceImpl);
    return MonitorServiceImpl;
}());
exports.MonitorServiceImpl = MonitorServiceImpl;
//# sourceMappingURL=monitor-service-impl.js.map