"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var path = require("path");
var fs = require("fs-extra");
var node_1 = require("@theia/core/lib/node");
var config_service_1 = require("../common/protocol/config-service");
exports.ALLOWED_FILE_EXTENSIONS = ['.c', '.cpp', '.h', '.hh', '.hpp', '.s', '.pde', '.ino'];
// TODO: `fs`: use async API 
var SketchesServiceImpl = /** @class */ (function () {
    function SketchesServiceImpl() {
    }
    SketchesServiceImpl.prototype.getSketches = function (uri) {
        return __awaiter(this, void 0, void 0, function () {
            var e_1, _a, sketches, fsPath, _b, _c, _d, fileNames, fileNames_1, fileNames_1_1, fileName, filePath, stat, e_1_1;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        sketches = [];
                        _c = (_b = node_1.FileUri).fsPath;
                        if (!uri) return [3 /*break*/, 1];
                        _d = uri;
                        return [3 /*break*/, 3];
                    case 1: return [4 /*yield*/, this.configService.getConfiguration()];
                    case 2:
                        _d = (_e.sent()).sketchDirUri;
                        _e.label = 3;
                    case 3:
                        fsPath = _c.apply(_b, [_d]);
                        fileNames = fs.readdirSync(fsPath);
                        _e.label = 4;
                    case 4:
                        _e.trys.push([4, 9, 10, 11]);
                        fileNames_1 = __values(fileNames), fileNames_1_1 = fileNames_1.next();
                        _e.label = 5;
                    case 5:
                        if (!!fileNames_1_1.done) return [3 /*break*/, 8];
                        fileName = fileNames_1_1.value;
                        filePath = path.join(fsPath, fileName);
                        return [4 /*yield*/, this.isSketchFolder(node_1.FileUri.create(filePath).toString())];
                    case 6:
                        if (_e.sent()) {
                            stat = fs.statSync(filePath);
                            sketches.push({
                                mtimeMs: stat.mtimeMs,
                                name: fileName,
                                uri: node_1.FileUri.create(filePath).toString()
                            });
                        }
                        _e.label = 7;
                    case 7:
                        fileNames_1_1 = fileNames_1.next();
                        return [3 /*break*/, 5];
                    case 8: return [3 /*break*/, 11];
                    case 9:
                        e_1_1 = _e.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 11];
                    case 10:
                        try {
                            if (fileNames_1_1 && !fileNames_1_1.done && (_a = fileNames_1.return)) _a.call(fileNames_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 11: return [2 /*return*/, sketches.sort(function (left, right) { return right.mtimeMs - left.mtimeMs; })];
                }
            });
        });
    };
    /**
     * Return all allowed files.
     * File extensions: 'c', 'cpp', 'h', 'hh', 'hpp', 's', 'pde', 'ino'
     */
    SketchesServiceImpl.prototype.getSketchFiles = function (uri) {
        return __awaiter(this, void 0, void 0, function () {
            var e_2, _a, uris, fsPath, stats, _b, fileNames, fileNames_2, fileNames_2_1, fileName, filePath, sketchDir;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        uris = [];
                        fsPath = node_1.FileUri.fsPath(uri);
                        stats = fs.lstatSync(fsPath);
                        _b = stats.isDirectory;
                        if (!_b) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.isSketchFolder(uri)];
                    case 1:
                        _b = (_c.sent());
                        _c.label = 2;
                    case 2:
                        if (_b) {
                            fileNames = fs.readdirSync(fsPath);
                            try {
                                for (fileNames_2 = __values(fileNames), fileNames_2_1 = fileNames_2.next(); !fileNames_2_1.done; fileNames_2_1 = fileNames_2.next()) {
                                    fileName = fileNames_2_1.value;
                                    filePath = path.join(fsPath, fileName);
                                    if (exports.ALLOWED_FILE_EXTENSIONS.indexOf(path.extname(filePath)) !== -1
                                        && fs.existsSync(filePath)
                                        && fs.lstatSync(filePath).isFile()) {
                                        uris.push(node_1.FileUri.create(filePath).toString());
                                    }
                                }
                            }
                            catch (e_2_1) { e_2 = { error: e_2_1 }; }
                            finally {
                                try {
                                    if (fileNames_2_1 && !fileNames_2_1.done && (_a = fileNames_2.return)) _a.call(fileNames_2);
                                }
                                finally { if (e_2) throw e_2.error; }
                            }
                            return [2 /*return*/, uris];
                        }
                        sketchDir = path.dirname(fsPath);
                        return [2 /*return*/, this.getSketchFiles(node_1.FileUri.create(sketchDir).toString())];
                }
            });
        });
    };
    SketchesServiceImpl.prototype.createNewSketch = function (parentUri) {
        return __awaiter(this, void 0, void 0, function () {
            var monthNames, today, parent, sketchBaseName, sketchName, i, sketchNameCandidate, sketchDir, sketchFile;
            return __generator(this, function (_a) {
                monthNames = ['january', 'february', 'march', 'april', 'may', 'june',
                    'july', 'august', 'september', 'october', 'november', 'december'
                ];
                today = new Date();
                parent = node_1.FileUri.fsPath(parentUri);
                sketchBaseName = "sketch_" + monthNames[today.getMonth()] + today.getDate();
                for (i = 97; i < 97 + 26; i++) {
                    sketchNameCandidate = "" + sketchBaseName + String.fromCharCode(i);
                    if (fs.existsSync(path.join(parent, sketchNameCandidate))) {
                        continue;
                    }
                    sketchName = sketchNameCandidate;
                    break;
                }
                if (!sketchName) {
                    throw new Error('Cannot create a unique sketch name');
                }
                sketchDir = path.join(parent, sketchName);
                sketchFile = path.join(sketchDir, sketchName + ".ino");
                fs.mkdirSync(sketchDir);
                fs.writeFileSync(sketchFile, "\nvoid setup() {\n// put your setup code here, to run once:\n\n}\n\nvoid loop() {\n// put your main code here, to run repeatedly:\n\n}\n", { encoding: 'utf8' });
                return [2 /*return*/, {
                        name: sketchName,
                        uri: node_1.FileUri.create(sketchDir).toString()
                    }];
            });
        });
    };
    SketchesServiceImpl.prototype.isSketchFolder = function (uri) {
        return __awaiter(this, void 0, void 0, function () {
            var fsPath, exists, stats, basename_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fsPath = node_1.FileUri.fsPath(uri);
                        return [4 /*yield*/, fs.pathExists(fsPath)];
                    case 1:
                        exists = _a.sent();
                        if (!exists) return [3 /*break*/, 3];
                        return [4 /*yield*/, fs.lstat(fsPath)];
                    case 2:
                        stats = _a.sent();
                        if (stats.isDirectory()) {
                            basename_1 = path.basename(fsPath);
                            return [2 /*return*/, new Promise(function (resolve, reject) {
                                    fs.readdir(fsPath, function (error, files) {
                                        if (error) {
                                            reject(error);
                                            return;
                                        }
                                        for (var i = 0; i < files.length; i++) {
                                            if (files[i] === basename_1 + '.ino') {
                                                resolve(true);
                                                return;
                                            }
                                        }
                                        resolve(false);
                                    });
                                })];
                        }
                        _a.label = 3;
                    case 3: return [2 /*return*/, false];
                }
            });
        });
    };
    __decorate([
        inversify_1.inject(config_service_1.ConfigService),
        __metadata("design:type", Object)
    ], SketchesServiceImpl.prototype, "configService", void 0);
    SketchesServiceImpl = __decorate([
        inversify_1.injectable()
    ], SketchesServiceImpl);
    return SketchesServiceImpl;
}());
exports.SketchesServiceImpl = SketchesServiceImpl;
//# sourceMappingURL=sketches-service-impl.js.map